#include <math.h>

inline double getRigidBodyEnergyi3D (
  double alpha,
  double beta,
  double edge2LengthOriginal,
  const double *tangentOriginalRigidBody,
  const double *materialNormalOriginalRigidBody,
  const double *tangentReferenceOriginal,
  const double *normalReferenceOriginal,
  double referenceFrameTwist,
  const double *x1,
  const double *rigidBodyAngles,
  const double *x2,
  double theta2)
{
  double t101;
  double t103;
  double t104;
  double t106;
  double t109;
  double t11;
  double t113;
  double t116;
  double t118;
  double t12;
  double t120;
  double t122;
  double t125;
  double t127;
  double t128;
  double t129;
  double t131;
  double t133;
  double t135;
  double t141;
  double t145;
  double t151;
  double t155;
  double t16;
  double t161;
  double t167;
  double t168;
  double t17;
  double t170;
  double t172;
  double t177;
  double t184;
  double t189;
  double t19;
  double t198;
  double t20;
  double t201;
  double t209;
  double t21;
  double t212;
  double t222;
  double t228;
  double t23;
  double t238;
  double t245;
  double t247;
  double t25;
  double t251;
  double t252;
  double t253;
  double t254;
  double t256;
  double t266;
  double t269;
  double t27;
  double t276;
  double t282;
  double t289;
  double t29;
  double t295;
  double t304;
  double t31;
  double t314;
  double t33;
  double t34;
  double t35;
  double t41;
  double t42;
  double t48;
  double t49;
  double t57;
  double t6;
  double t62;
  double t64;
  double t67;
  double t7;
  double t72;
  double t75;
  double t76;
  double t77;
  double t78;
  double t79;
  double t80;
  double t81;
  double t82;
  double t84;
  double t85;
  double t86;
  double t87;
  double t89;
  double t90;
  double t92;
  double t93;
  double t97;
  double t98;
  t6 = x2[0] - 0.1e1 * x1[0];
  t7 = t6 * t6;
  t11 = x2[1] - 0.1e1 * x1[1];
  t12 = t11 * t11;
  t16 = x2[2] - 0.1e1 * x1[2];
  t17 = t16 * t16;
  t19 = sqrt(t7 + t12 + t17);
  t20 = 0.1e1 / t19;
  t21 = t20 * t11;
  t23 = tangentReferenceOriginal[0] * t20;
  t25 = 0.1e1 * t23 * t6;
  t27 = tangentReferenceOriginal[1] * t20;
  t29 = 0.1e1 * t27 * t11;
  t31 = tangentReferenceOriginal[2] * t20;
  t33 = 0.1e1 * t31 * t16;
  t34 = t25 + t29 + t33;
  t35 = normalReferenceOriginal[2];
  t41 = 0.1e1 * t27 * t16 - 0.1e1 * t31 * t11;
  t42 = normalReferenceOriginal[1];
  t48 = -0.1e1 * t23 * t16 + 0.1e1 * t31 * t6;
  t49 = normalReferenceOriginal[0];
  t57 = 0.1e1 * t23 * t11 - 0.1e1 * t27 * t6;
  t62 = (t35 * t57 + t41 * t49 + t42 * t48) / (0.1e1 + t25 + t29 + t33);
  t64 = t34 * t35 + t41 * t42 - t48 * t49 + t57 * t62;
  t67 = t20 * t16;
  t72 = t34 * t42 - t35 * t41 + t48 * t62 + t49 * t57;
  t75 = 0.1e1 * t21 * t64 - 0.1e1 * t67 * t72;
  t76 = cos(referenceFrameTwist);
  t77 = rigidBodyAngles[2];
  t78 = cos(t77);
  t79 = rigidBodyAngles[1];
  t80 = cos(t79);
  t81 = t78 * t80;
  t82 = tangentOriginalRigidBody[0];
  t84 = sin(t79);
  t85 = t78 * t84;
  t86 = rigidBodyAngles[0];
  t87 = sin(t86);
  t89 = sin(t77);
  t90 = cos(t86);
  t92 = t85 * t87 - t89 * t90;
  t93 = tangentOriginalRigidBody[1];
  t97 = t85 * t90 + t87 * t89;
  t98 = tangentOriginalRigidBody[2];
  t101 = (t81 * t82 + t92 * t93 + t97 * t98) * t20;
  t103 = 0.1e1 * t101 * t6;
  t104 = t89 * t80;
  t106 = t89 * t84;
  t109 = t106 * t87 + t78 * t90;
  t113 = t106 * t90 - t78 * t87;
  t116 = (t104 * t82 + t109 * t93 + t113 * t98) * t20;
  t118 = 0.1e1 * t116 * t11;
  t120 = t80 * t87;
  t122 = t80 * t90;
  t125 = (t120 * t93 + t122 * t98 - t82 * t84) * t20;
  t127 = 0.1e1 * t125 * t16;
  t128 = t103 + t118 + t127;
  t129 = materialNormalOriginalRigidBody[0];
  t131 = materialNormalOriginalRigidBody[1];
  t133 = materialNormalOriginalRigidBody[2];
  t135 = t129 * t81 + t131 * t92 + t133 * t97;
  t141 = -0.1e1 * t16 * t101 + 0.1e1 * t125 * t6;
  t145 = t120 * t131 + t122 * t133 - t129 * t84;
  t151 = 0.1e1 * t101 * t11 - 0.1e1 * t116 * t6;
  t155 = t104 * t129 + t109 * t131 + t113 * t133;
  t161 = 0.1e1 * t116 * t16 - 0.1e1 * t125 * t11;
  t167 = 0.1e1 / (0.1e1 + t103 + t118 + t127);
  t168 = (t135 * t161 + t141 * t155 + t145 * t151) * t167;
  t170 = t128 * t135 + t141 * t145 - t151 * t155 + t161 * t168;
  t172 = sin(referenceFrameTwist);
  t177 = t128 * t145 - t135 * t141 + t151 * t168 + t155 * t161;
  t184 = t128 * t155 + t135 * t151 + t141 * t168 - t145 * t161;
  t189 = t20 * t6;
  t198 = (0.1e1 * t189 * t170 + 0.1e1 * t21 * t184 + 0.1e1 * t67 * t177) * (0.1e1 - t76);
  t201 = t76 * t170 + t172 * (0.1e1 * t177 * t21 - 0.1e1 * t67 * t184) + 0.1e1 * t198 * t189;
  t209 = t34 * t49 + t35 * t48 + t41 * t62 - t42 * t57;
  t212 = -0.1e1 * t189 * t64 + 0.1e1 * t67 * t209;
  t222 = t76 * t184 + t172 * (-0.1e1 * t189 * t177 + 0.1e1 * t67 * t170) + 0.1e1 * t198 * t21;
  t228 = 0.1e1 * t189 * t72 - 0.1e1 * t21 * t209;
  t238 = t76 * t177 + t172 * (0.1e1 * t184 * t189 - 0.1e1 * t21 * t170) + 0.1e1 * t198 * t67;
  t245 = atan2(t201 * t75 + t212 * t222 + t228 * t238, t201 * t209 + t222 * t72 + t238 * t64);
  t247 = pow(theta2 + referenceFrameTwist - t245, 0.2e1);
  t251 = edge2LengthOriginal * edge2LengthOriginal;
  t252 = 0.1e1 / t251;
  t253 = t167 * t161;
  t254 = cos(theta2);
  t256 = sin(theta2);
  t266 = (0.1e1 * t189 * t209 + 0.1e1 * t21 * t72 + 0.1e1 * t67 * t64) * (0.1e1 - t254);
  t269 = t254 * t64 + t256 * t228 + 0.1e1 * t266 * t67;
  t276 = t254 * t72 + t256 * t212 + 0.1e1 * t266 * t21;
  t282 = t167 * t141;
  t289 = t254 * t209 + t256 * t75 + 0.1e1 * t266 * t189;
  t295 = t167 * t151;
  t304 = pow(0.2e1 * t253 * (0.1e1 * t21 * t269 - 0.1e1 * t67 * t276) + 0.2e1 * t282 * (-0.1e1 * t189 * t269 + 0.1e1 * t67 * t289) + 0.2e1 * t295 * (0.1e1 * t189 * t276 - 0.1e1 * t21 * t289), 0.2e1);
  t314 = pow(-0.2e1 * t253 * t289 - 0.2e1 * t282 * t276 - 0.2e1 * t295 * t269, 0.2e1);
  return(0.1000000000e1 * beta / edge2LengthOriginal * t247 + 0.2500000000e0 * alpha * edge2LengthOriginal * (0.4000000000e1 * t252 * t304 + 0.4000000000e1 * t252 * t314));
}
